<!DOCTYPE HTML PUBLIC "-//W3O//DTD W3 HTML 2.0//EN">
<!-- This collection of hypertext pages is Copyright 1995, 1996 by Steve Summit. -->
<!-- This material may be freely redistributed and used -->
<!-- but may not be republished or sold without permission. -->
<html>
<head>
<link rev="owner" href="mailto:scs@eskimo.com">
<link rev="made" href="mailto:scs@eskimo.com">
<title>3.1 Expression Statements</title>
<link href="sx3.html" rev=precedes>
<link href="sx3b.html" rel=precedes>
<link href="sx3.html" rev=subdocument>
</head>
<body>
<H2>3.1 Expression Statements</H2>

<p>[This section corresponds to K&amp;R Sec. 3.1]
</p><p>Most of the statements in a C program are <dfn>expression statements</dfn>.
An expression statement is simply an expression followed by a semicolon.
The lines
<pre>
	i = 0;
	i = i + 1;
and
	printf("Hello, world!\n");
</pre>
are all expression statements.
(In some languages, such as Pascal,
the semicolon separates statements,
such that the last statement is not followed by a semicolon.
In C, however, the semicolon is a statement terminator;
all simple statements are followed by semicolons.
The semicolon is also used for a few other things in C;
we've already seen that it terminates declarations, too.)
</p><p>Expression statements do all of the real work in a C program.
Whenever you need to compute new values for variables,
you'll typically use expression statements
(and they'll typically contain assignment operators).
Whenever you want your program to do something visible,
in the real world,
you'll typically call a function
(as part of an expression statement).
We've already seen the most basic example:
calling the function <TT>printf</TT> to print text to the screen.
But anything else you might do--read or write a disk file,
talk to a modem or printer,
draw pictures on the screen--will
also involve function calls.
(Furthermore, the functions you call to do these things
are usually different depending on which operating system you're using.
The C language does not define them,
so we won't be talking about or using them much.)
</p><p>Expressions and expression statements can be arbitrarily complicated.
They don't have to consist of exactly one simple function call,
or of one simple assignment to a variable.
For one thing,
many functions return values,
and the values they return can then be used
by other parts of the expression.
For example, C provides a <TT>sqrt</TT> (square root) function,
which we might use to compute the hypotenuse of a right 
triangle like this:
<pre>
	c = sqrt(a*a + b*b);
</pre>
</p><p>To be useful, an expression statement must
do something;
it must have some lasting effect on the state of the program.
(Formally, a useful statement must have at least one
<dfn>side effect</dfn>.)
The first two
sample
expression
statements
in this section
(above)
assign new values to the
variable <TT>i</TT>,
and the third one calls <TT>printf</TT> to print something out,
and these are good examples of statements that do something useful.
</p><p>(To make the distinction clear, we may note that degenerate
constructions such as
<pre>
	0;
	i;
or
	i + 1;
</pre>
are syntactically valid statements--they
consist of an expression followed by a semicolon--but
in each case,
they compute a value without doing anything with it,
so the computed value is discarded,
and the statement is useless.
But if
the ``degenerate'' statements in this paragraph
don't make much sense to you, don't worry;
it's because they, frankly, don't make much sense.)
</p><p>It's also possible for a single expression to have multiple
side effects, but it's easy for such an expression to be
(a) confusing or (b) undefined.
For now, we'll only be looking at expressions
(and, therefore, statements)
which do one well-defined thing at a time.
</p><hr>
<p>
Read sequentially:
<a href="sx3.html" rev=precedes>prev</a>
<a href="sx3b.html" rel=precedes>next</a>
<a href="sx3.html" rev=subdocument>up</a>
<a href="top.html">top</a>
</p>
<p>
This page by <a href="http://www.eskimo.com/~scs/">Steve Summit</a>
// <a href="copyright.html">Copyright</a> 1995, 1996
// <a href="mailto:scs@eskimo.com">mail feedback</a>
</p>
</body>
</html>
